#utf-8
import os
import threading
import time
import traceback

from lib.socket.service.M500PressureServer import M500PressureServer

#写入文件
def writeToFile(path,data,type=1):         #1：代表追加  0：代表覆盖
    if(type == 1):
        with open(path, "a", encoding='utf-8') as fi:
            fi.write(data)
    else:
        with open(path, "w", encoding='utf-8') as fi:
            fi.write(data)

carNums = 3000                 #模拟器数量
durTime = 86400                 #线程持续的时间
startDin = 202008280000       #开始的车机号
info = {}                    #存放脚本运行时的信息
info["threadsObj"] = {}              #用于运行线程的字典
info["failT"] = {}                   #失败线程
info["sucessT"] = {}                 #成功线程


def startSimulaterService():
    timeS = int(time.time())
    timeArray = time.localtime(timeS)
    startTime = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
    for i in range(0,carNums):
        carId = "M" + str(startDin + i)
        autoCarObj = M500PressureServer()
        autoCarObj.setHost("172.19.7.6")
        autoCarObj.setPort(49008)
        autoCarObj.setInfo(info)
        autoCarObj.setSendDur(5)
        autoCarObj.setCarId(carId)
        autoCarObj.setDurTime(durTime)
        threadId = "thread_" + str(i)
        autoCarObj.setThreadName("thread_" + str(i))
        info["threadsObj"][threadId] = autoCarObj
        thread_hello = threading.Thread(target=autoCarObj.startService)
        thread_hello.start()
        print("启动了线程：" + threadId + "车机号：" + carId)
        timeS = int(time.time())
        timeArray = time.localtime(timeS)
        datetime = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
        writeToFile("data/log1.txt", "[" + datetime + "]" + "启动了线程：" + threadId + "车机号：" + carId + "\n", type=1)

    while(len(info["threadsObj"]) > 0):
        time.sleep(5)
        threadNums = len(info["threadsObj"])
        print("[" + datetime + "]" + "剩余线程数：" + str(threadNums))
        timeS = int(time.time())
        timeArray = time.localtime(timeS)
        datetime = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
        writeToFile("data/log1.txt", "[" + datetime + "]" + "剩余线程数：" + str(threadNums) + "\n", type=1)
        print("成功线程数：" + str(len(info["sucessT"])))
        print("失败线程数：" + str(len(info["failT"])))
        writeToFile("data/log1.txt", "成功线程数：" + str(len(info["sucessT"])) + "\n", type=1)
        writeToFile("data/log1.txt", "失败线程数：" + str(len(info["failT"])) + "\n", type=1)

    timeS = int(time.time())
    timeArray = time.localtime(timeS)
    datetime = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
    threadNums = len(info["threadsObj"])
    print("剩余线程数：" + str(threadNums) + "\n")
    writeToFile("data/log1.txt", "[" + datetime + "]" + "剩余线程数：" + str(threadNums) + "\n", type=1)

    print("----------------------------------------------")
    writeToFile("data/log1.txt", "----------------------------------------------\n", type=1)
    timeS = int(time.time())
    timeArray = time.localtime(timeS)
    endTime = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
    print("开始测试时间：" + startTime)
    print("结束测试时间：" + endTime)
    print("线程总数：" + str(carNums))
    print("成功线程数：" + str(len(info["sucessT"])))
    print("失败线程数：" + str(len(info["failT"])))
    print("设置线程持续时间：" + str(durTime))
    writeToFile("data/log1.txt", "开始测试时间：" + startTime + "\n", type=1)
    writeToFile("data/log1.txt", "结束测试时间：" + endTime + "\n", type=1)
    writeToFile("data/log1.txt", "线程总数：" + str(carNums) + "\n", type=1)
    writeToFile("data/log1.txt", "成功线程数：" + str(len(info["sucessT"])) + "\n", type=1)
    writeToFile("data/log1.txt", "失败线程数：" + str(len(info["failT"])) + "\n", type=1)
    writeToFile("data/log1.txt", "设置线程持续时间：" + str(durTime) + "\n", type=1)



if __name__ == "__main__":
    try:
        os.remove("data/log1.txt")
        startSimulaterService()
    except BaseException as e:
        traceback.print_exc()
        timeS = int(time.time())
        timeArray = time.localtime(timeS)
        datetime = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
        err = traceback.format_exc()
        writeToFile("data/log1.txt", "[" + datetime + "]", type=1)
        writeToFile("data/log1.txt", err, type=1)




